#include "C:/Programme/pure-systems/AspectC++ Add-In/include/vsbasics.h"

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"
#ifndef __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__
#define __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__
#define __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_Action1_cpp__
#endif // __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 12 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

#ifndef __ac_h_
#define __ac_h_
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    char _data[sizeof (T)];
    ~ResultBuffer () { ((T*)_data)->T::~T(); }
    operator T& () const { return *(T*)_data; }
  };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __ac_h_

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 49 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

#ifndef __ac_fwd_Profiling__
#define __ac_fwd_Profiling__
class Profiling;
namespace AC {
  inline void invoke_Profiling_Profiling_a0_before ();
  inline void invoke_Profiling_Profiling_a1_after ();
  inline void invoke_Profiling_Profiling_a2_after ();
}
#endif

#ifndef __ac_need_C__DA_ACSTUTest_aspects_Profiling_ah__
#define __ac_need_C__DA_ACSTUTest_aspects_Profiling_ah__
#endif

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.h"
#ifndef ACTION1_H
#define ACTION1_H
#include <iostream>


#line 73 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"
class ErrorHandling;
class Profiling;

#line 5 "c:/Da/ACSTUTest/ACSTUTest/Action1.h"
class Action1
{
#line 80 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;

#line 6 "c:/Da/ACSTUTest/ACSTUTest/Action1.h"

public:
	Action1(){}
	~Action1(){}
	int execute();
	int checkpoint();
private:
	void printface();

};
#endif
#line 2 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"
void Action1::printface()
{
	int i,j;
	std::cout<<"\1\1"<<std::endl;
	for(i=1;i<21;i++)
	{
		for(j=1;j<=i;j++) std::cout<<(char)219<<(char)219;
		std::cout<<std::endl;
	}
}

int Action1::checkpoint(){
	std::cout << "checkpoint"<<std::endl;
	return 0;
}

#line 113 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_1_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 124 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_3_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 135 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_5_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 146 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_7_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 157 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_9_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 168 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_11_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 179 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_13_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 190 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_15_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 201 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_17_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"

#line 212 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

inline int __call__ZN7Action17executeEv_19_0 (::Action1 *srcthis, ::Action1 *dstthis){
  AC::ResultBuffer< int  > result;
  ::new (&result) int  (dstthis->checkpoint());
  AC::invoke_Profiling_Profiling_a1_after ();
  return (int &)result;
 }

#line 17 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"
int Action1::execute()
{
	printface();
	__call__ZN7Action17executeEv_1_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_3_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_5_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_7_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_9_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_11_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_13_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_15_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_17_0 ((::Action1*)this,(::Action1*)this);
	printface();
	__call__ZN7Action17executeEv_19_0 ((::Action1*)this,(::Action1*)this);
	return 0;
}
#line 246 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

#ifdef __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_Action1_cpp__
/*** begin of aspect includes ***/
#if !defined(__ac_have_C__DA_ACSTUTest_aspects_ErrorHandling_ah__) && defined(__ac_need_C__DA_ACSTUTest_aspects_ErrorHandling_ah__)
#define __ac_have_C__DA_ACSTUTest_aspects_ErrorHandling_ah__
#include "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"
#endif
#if !defined(__ac_have_C__DA_ACSTUTest_aspects_Profiling_ah__) && defined(__ac_need_C__DA_ACSTUTest_aspects_Profiling_ah__)
#define __ac_have_C__DA_ACSTUTest_aspects_Profiling_ah__

#line 1 "c:/Da/ACSTUTest/aspects/Profiling.ah"
#ifndef Profiling_ah
#define Profiling_ah

#line 4 "c:/Da/ACSTUTest/aspects/Profiling.ah"
#include <windows.h>

#line 264 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"
class ErrorHandling;

#line 5 "c:/Da/ACSTUTest/aspects/Profiling.ah"
class Profiling {
#line 269 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

public:
  static Profiling *aspectof () {
    static Profiling __instance;
    return &__instance;
  }
  static Profiling *aspectOf () {
    return aspectof ();
  }
private:

#line 5 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 283 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"
  friend class ::ErrorHandling;

#line 5 "c:/Da/ACSTUTest/aspects/Profiling.ah"


  public:
	
#line 8 "c:/Da/ACSTUTest/aspects/Profiling.ah"

	
#line 9 "c:/Da/ACSTUTest/aspects/Profiling.ah"

    DWORD getTime();
    DWORD getStartTime();
    void SetStartTime(DWORD temp);

	static DWORD timeAmount;
    static DWORD MaximaTime;
 private:
    DWORD _dwStart;
	DWORD _dwEnd;
   	DWORD _checkpoint;
public:
	
#line 3 "c:/Da/ACSTUTest/aspects/Profiling.ah"

public: void __a0_before 
#line 21 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 21 "c:/Da/ACSTUTest/aspects/Profiling.ah"
()
#line 21 "c:/Da/ACSTUTest/aspects/Profiling.ah"

	{
		DWORD _dwtemp = getTime();
        SetStartTime(_dwtemp);
        std::cout << "This "<<this<<std::endl;
        std::cout << "**loggedOperations _dwStart is " <<_dwStart << std::endl; 
        std::cout << "**loggedOperations getStartTime() is " <<getStartTime() << std::endl; 
		_dwEnd = 0;
        _checkpoint = 0;
	}
    
#line 3 "c:/Da/ACSTUTest/aspects/Profiling.ah"

public: void __a1_after 
#line 31 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 31 "c:/Da/ACSTUTest/aspects/Profiling.ah"
()
#line 31 "c:/Da/ACSTUTest/aspects/Profiling.ah"

    {
        _checkpoint = getTime();
        std::cout << "This "<<this<<std::endl;
        std::cout << "**checkedOperations _dwStart is " <<_dwStart << std::endl; 
        std::cout << "**checkedOperations getStartTime() is " <<getStartTime() << std::endl; 

        DWORD tempvalue = _checkpoint - _dwStart;
        std::cout <<"Check point time is " << _checkpoint <<", duration " << tempvalue<< std::endl;
        if(tempvalue>MaximaTime) 
        {
			std::cout << "action exceed the maximal run time, action must be abort!!!"<<std::endl;
            throw ("Expnd Time");		
        }
    }

	
#line 3 "c:/Da/ACSTUTest/aspects/Profiling.ah"

public: void __a2_after 
#line 47 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 47 "c:/Da/ACSTUTest/aspects/Profiling.ah"
()
#line 47 "c:/Da/ACSTUTest/aspects/Profiling.ah"

	{
		_dwEnd =getTime();		
		timeAmount += _dwEnd - _dwStart ;
		std::cout << "*************time span is " <<_dwEnd - _dwStart << std::endl; 
		std::cout << "*************time amount  is " <<timeAmount << std::endl; 
	}
};
#line 368 "c:/Da/ACSTUTest/ACSTUTest/Debug/Action1.cpp"

namespace AC {
  inline void invoke_Profiling_Profiling_a0_before () {
    ::Profiling::aspectof()->__a0_before ();
  }
  inline void invoke_Profiling_Profiling_a1_after () {
    ::Profiling::aspectof()->__a1_after ();
  }
  inline void invoke_Profiling_Profiling_a2_after () {
    ::Profiling::aspectof()->__a2_after ();
  }
} 

#line 54 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#endif
DWORD Profiling::timeAmount=0;
DWORD Profiling::MaximaTime=5000;

DWORD Profiling::getTime()
{
	DWORD tickCount = GetTickCount();
	return tickCount;
}
DWORD Profiling::getStartTime()
{
	return _dwStart;
}
void Profiling::SetStartTime(DWORD time)
{
	_dwStart = time;
}
#line 11 "c:/Da/ACSTUTest/ACSTUTest/Action1.cpp"
#endif
/*** end of aspect includes ***/
#undef __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__
#undef __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_Action1_cpp__
#endif // __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_Action1_cpp__
