#include "C:/Programme/pure-systems/AspectC++ Add-In/include/vsbasics.h"

#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"
#ifndef __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__
#define __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__
#define __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_ActionMng_cpp__
#endif // __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__

#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"

#line 12 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

#ifndef __ac_h_
#define __ac_h_
namespace AC {
  typedef const char* Type;
  enum JPType { CALL = 0x0004, EXECUTION = 0x0008, CONSTRUCTION = 0x0010, DESTRUCTION = 0x0020 };
  struct Action {
    void **_args; void *_result; void *_target; void *_that; void *_fptr;
    void (*_wrapper)(Action &);
    inline void trigger () { _wrapper (*this); }
  };
  struct AnyResultBuffer {};
  template <typename T> struct ResultBuffer : public AnyResultBuffer {
    char _data[sizeof (T)];
    ~ResultBuffer () { ((T*)_data)->T::~T(); }
    operator T& () const { return *(T*)_data; }
  };
  template <class Aspect, int Index>
  struct CFlow {
    static int &instance () {
      static int counter = 0;
      return counter;
    }
    CFlow () { instance ()++; }
    ~CFlow () { instance ()--; }
    static bool active () { return instance () > 0; }
  };
}
inline void * operator new (unsigned int, AC::AnyResultBuffer *p) { return p; }
inline void operator delete (void *, AC::AnyResultBuffer *) { } // for VC++
#endif // __ac_h_

#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"

#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"

#line 49 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

#ifndef __ac_fwd_ErrorHandling__
#define __ac_fwd_ErrorHandling__
class ErrorHandling;
namespace AC {
  template <class JoinPoint>
  inline void invoke_ErrorHandling_ErrorHandling_a0_around (JoinPoint *tjp);
}
#endif

#ifndef __ac_need_C__DA_ACSTUTest_aspects_ErrorHandling_ah__
#define __ac_need_C__DA_ACSTUTest_aspects_ErrorHandling_ah__
#endif

#ifndef __ac_fwd_Profiling__
#define __ac_fwd_Profiling__
class Profiling;
namespace AC {
  inline void invoke_Profiling_Profiling_a0_before ();
  inline void invoke_Profiling_Profiling_a1_after ();
  inline void invoke_Profiling_Profiling_a2_after ();
}
#endif

#ifndef __ac_need_C__DA_ACSTUTest_aspects_Profiling_ah__
#define __ac_need_C__DA_ACSTUTest_aspects_Profiling_ah__
#endif

#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"

#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.h"
#ifndef ACTIONMNG_H
#define ACTIONMNG_H
#include <iostream>

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.h"
#ifndef ACTION1_H
#define ACTION1_H

#line 1 "c:/Da/ACSTUTest/ACSTUTest/Action1.h"

#line 91 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
class ErrorHandling;
class Profiling;

#line 5 "c:/Da/ACSTUTest/ACSTUTest/Action1.h"
class Action1
{
#line 98 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;

#line 6 "c:/Da/ACSTUTest/ACSTUTest/Action1.h"

public:
	Action1(){}
	~Action1(){}
	int execute();
	int checkpoint();
private:
	void printface();

};
#endif
#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.h"

#line 116 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
class ErrorHandling;
class Profiling;

#line 5 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.h"
class ActionMng{
#line 122 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
  friend class ::ErrorHandling;
  friend class ::Profiling;

#line 5 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.h"

public:
	ActionMng(){}
	~ActionMng(){}
	int executeActions();

};
#endif
#line 1 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"

#line 137 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

struct TJP__ZN9ActionMng14executeActionsEv_0_0 {
  typedef int Result;
  typedef ::ActionMng That;
  typedef ::Action1 Target;
  static const int JPID = 0;
  static const AC::JPType JPTYPE = (AC::JPType)4;
  struct Res {
    typedef int Type;
    typedef int ReferredType;
  };
  enum { ARGS = 0 };
  template <int I> struct Arg {
    typedef void Type;
    typedef void ReferredType;
  };

  Result *_result;
  Target *_target;

  inline static const char *signature () { return "int Action1::execute()";}
  inline Result *result() {return (Result*)_result;}
  inline Target *target() {return (Target*)_target;}

};


struct TJP__ZN9ActionMng14executeActionsEv_0_1 : TJP__ZN9ActionMng14executeActionsEv_0_0 {
  void proceed () {
  AC::invoke_Profiling_Profiling_a0_before ();
  ::new ((AC::ResultBuffer< int  >*)_result) int  (((TJP__ZN9ActionMng14executeActionsEv_0_0::Target*)_target)->execute());
  AC::invoke_Profiling_Profiling_a2_after ();
  }
};


#line 2 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"

#line 176 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

inline int __call__ZN9ActionMng14executeActionsEv_0_1 (::ActionMng *srcthis, ::Action1  *dstthis){
  AC::ResultBuffer< int  > result;
  TJP__ZN9ActionMng14executeActionsEv_0_1 tjp;
  tjp._result = &(TJP__ZN9ActionMng14executeActionsEv_0_1::Result&)result;
  tjp._target =  (TJP__ZN9ActionMng14executeActionsEv_0_1::Target*)dstthis;
  AC::invoke_ErrorHandling_ErrorHandling_a0_around<TJP__ZN9ActionMng14executeActionsEv_0_1> (&tjp);
  return (int &)result;
 }

#line 2 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"
ActionMng::executeActions()
{
	int hr =-1;
	Action1 action_1;
	hr = __call__ZN9ActionMng14executeActionsEv_0_1 ((::ActionMng*)this,&(action_1));
	return hr;
}
#line 195 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

#ifdef __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_ActionMng_cpp__
/*** begin of aspect includes ***/
#if !defined(__ac_have_C__DA_ACSTUTest_aspects_ErrorHandling_ah__) && defined(__ac_need_C__DA_ACSTUTest_aspects_ErrorHandling_ah__)
#define __ac_have_C__DA_ACSTUTest_aspects_ErrorHandling_ah__

#line 1 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"
#ifndef ErrorHandling_ah
#define ErrorHandling_ah


#line 1 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

#line 209 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
class Profiling;

#line 6 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"
class ErrorHandling
{
#line 215 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

public:
  static ErrorHandling *aspectof () {
    static ErrorHandling __instance;
    return &__instance;
  }
  static ErrorHandling *aspectOf () {
    return aspectof ();
  }
private:

#line 7 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

#line 229 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
  friend class ::Profiling;

#line 7 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

    
#line 8 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

    //pointcut loggedOperations() = call("% PROA%::QueryInterface(...)");// && cflow(execution("void PROA%::%(...)"));

    
#line 3 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

public: template<class JoinPoint> void __a0_around 
#line 11 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

#line 11 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"
(JoinPoint *tjp)
#line 11 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

    {
#line 250 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

  typedef typename JoinPoint::That __JP_That;
  typedef typename JoinPoint::Target __JP_Target;
  typedef typename JoinPoint::Result __JP_Result;

#line 12 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

        std::cout<<"++++"<<tjp->signature()<<std::endl;
		//printf("that  : %p\n" , tjp->that());
		//printf("target: %p\n" ,tjp->target());
        try
        {
             tjp->proceed();
        } 
        catch(...)
        {
            std::cout << "ERROR!!!" << std::endl;
            return;
        }
    }
#line 271 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

private:

#line 25 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"


};
#line 279 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

namespace AC {
  template <class JoinPoint>
  inline void invoke_ErrorHandling_ErrorHandling_a0_around (JoinPoint *tjp) {
    ::ErrorHandling::aspectof()->__a0_around (tjp);
  }
} 

#line 27 "c:/Da/ACSTUTest/aspects/ErrorHandling.ah"

#endif
#line 7 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"
#endif
#if !defined(__ac_have_C__DA_ACSTUTest_aspects_Profiling_ah__) && defined(__ac_need_C__DA_ACSTUTest_aspects_Profiling_ah__)
#define __ac_have_C__DA_ACSTUTest_aspects_Profiling_ah__

#line 1 "c:/Da/ACSTUTest/aspects/Profiling.ah"
#ifndef Profiling_ah
#define Profiling_ah

#line 4 "c:/Da/ACSTUTest/aspects/Profiling.ah"
#include <windows.h>

#line 303 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
class ErrorHandling;

#line 5 "c:/Da/ACSTUTest/aspects/Profiling.ah"
class Profiling {
#line 308 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

public:
  static Profiling *aspectof () {
    static Profiling __instance;
    return &__instance;
  }
  static Profiling *aspectOf () {
    return aspectof ();
  }
private:

#line 5 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 322 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"
  friend class ::ErrorHandling;

#line 5 "c:/Da/ACSTUTest/aspects/Profiling.ah"


  public:
	
#line 8 "c:/Da/ACSTUTest/aspects/Profiling.ah"

	
#line 9 "c:/Da/ACSTUTest/aspects/Profiling.ah"

    DWORD getTime();
    DWORD getStartTime();
    void SetStartTime(DWORD temp);

	static DWORD timeAmount;
    static DWORD MaximaTime;
 private:
    DWORD _dwStart;
	DWORD _dwEnd;
   	DWORD _checkpoint;
public:
	
#line 3 "c:/Da/ACSTUTest/aspects/Profiling.ah"

public: void __a0_before 
#line 21 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 21 "c:/Da/ACSTUTest/aspects/Profiling.ah"
()
#line 21 "c:/Da/ACSTUTest/aspects/Profiling.ah"

	{
		DWORD _dwtemp = getTime();
        SetStartTime(_dwtemp);
        std::cout << "This "<<this<<std::endl;
        std::cout << "**loggedOperations _dwStart is " <<_dwStart << std::endl; 
        std::cout << "**loggedOperations getStartTime() is " <<getStartTime() << std::endl; 
		_dwEnd = 0;
        _checkpoint = 0;
	}
    
#line 3 "c:/Da/ACSTUTest/aspects/Profiling.ah"

public: void __a1_after 
#line 31 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 31 "c:/Da/ACSTUTest/aspects/Profiling.ah"
()
#line 31 "c:/Da/ACSTUTest/aspects/Profiling.ah"

    {
        _checkpoint = getTime();
        std::cout << "This "<<this<<std::endl;
        std::cout << "**checkedOperations _dwStart is " <<_dwStart << std::endl; 
        std::cout << "**checkedOperations getStartTime() is " <<getStartTime() << std::endl; 

        DWORD tempvalue = _checkpoint - _dwStart;
        std::cout <<"Check point time is " << _checkpoint <<", duration " << tempvalue<< std::endl;
        if(tempvalue>MaximaTime) 
        {
			std::cout << "action exceed the maximal run time, action must be abort!!!"<<std::endl;
            throw ("Expnd Time");		
        }
    }

	
#line 3 "c:/Da/ACSTUTest/aspects/Profiling.ah"

public: void __a2_after 
#line 47 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#line 47 "c:/Da/ACSTUTest/aspects/Profiling.ah"
()
#line 47 "c:/Da/ACSTUTest/aspects/Profiling.ah"

	{
		_dwEnd =getTime();		
		timeAmount += _dwEnd - _dwStart ;
		std::cout << "*************time span is " <<_dwEnd - _dwStart << std::endl; 
		std::cout << "*************time amount  is " <<timeAmount << std::endl; 
	}
};
#line 407 "c:/Da/ACSTUTest/ACSTUTest/Debug/ActionMng.cpp"

namespace AC {
  inline void invoke_Profiling_Profiling_a0_before () {
    ::Profiling::aspectof()->__a0_before ();
  }
  inline void invoke_Profiling_Profiling_a1_after () {
    ::Profiling::aspectof()->__a1_after ();
  }
  inline void invoke_Profiling_Profiling_a2_after () {
    ::Profiling::aspectof()->__a2_after ();
  }
} 

#line 54 "c:/Da/ACSTUTest/aspects/Profiling.ah"

#endif
DWORD Profiling::timeAmount=0;
DWORD Profiling::MaximaTime=5000;

DWORD Profiling::getTime()
{
	DWORD tickCount = GetTickCount();
	return tickCount;
}
DWORD Profiling::getStartTime()
{
	return _dwStart;
}
void Profiling::SetStartTime(DWORD time)
{
	_dwStart = time;
}
#line 11 "c:/Da/ACSTUTest/ACSTUTest/ActionMng.cpp"
#endif
/*** end of aspect includes ***/
#undef __ac_FIRST_C__DA_ACSTUTest_ACSTUTest_ac4343_proj__
#undef __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_ActionMng_cpp__
#endif // __ac_FIRST_FILE_C__DA_ACSTUTest_ACSTUTest_ActionMng_cpp__
